<?php
/****************************************************************
* Converter for Aeva Media 1.0									*
*  Noisen.com & SMF-Media.com									*
*****************************************************************
* mgconverter_cpg.php - Converts Coppermine to Aeva Media		*
*****************************************************************
* Users of this software are bound by the terms of the			*
* Aeva Media license. You can view it in the license_am.txt		*
* file, or online at http://noisen.com/license.php				*
*																*
* Support and updates for this software can be found at			*
* http://aeva.noisen.com and http://smf-media.com				*
****************************************************************/

$path_to_ssi = dirname(__FILE__) . '/SSI.php';
if (file_exists($path_to_ssi))
	require_once($path_to_ssi);
else
	die('SSI.php was not found');

global $sourcedir, $context, $modSettings, $txt;

require_once($sourcedir . '/Aeva-Subs.php');
require_once($sourcedir . '/Subs-Package.php');
$context['template_layers'] = array();
$context['template_layers'] = array('mg_converter');

// You can set these to higher numbers if your server can handle the load.
$context['max_exec'] = 5;
$context['wait_time'] = 1;

// The whole "delete" part was copied from the SMF code. Thanks, guys!
if (isset($_GET['delete']))
{
	@unlink(__FILE__);

	header('Location: http://' . (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT']) . dirname($_SERVER['PHP_SELF']) . '/Themes/default/images/blank.gif');
	exit;
}

// Initialize the conversion
initConverter();

obExit();

// Loads the converter
function initConverter()
{
	global $amFunc, $amSettings, $modSettings, $CONFIG, $cpg_prefix, $boardurl, $converter_url, $context;

	// The converter's URL
	$converter_url = $_SERVER['PHP_SELF'];

	// Load the gallery
	aeva_loadSettings(null, false, true);

	// Are you allowed to convert?
	if (!aeva_allowedTo('manage'))
		convert_error('You are not allowed to make the conversion');

	$CONFIG = array();

	// Have we found Coppermine yet?
	if (isset($amSettings['cpg_conv_loaded']) && $amSettings['cpg_conv_loaded'] && !isset($_GET['safe_mode']))
	{
		// OK, load it then
		require_once($amSettings['cpg_path'].'/include/config.inc.php');
		$cpg_prefix = '`'.$CONFIG['dbname'].'`.' . $CONFIG['TABLE_PREFIX'];
		define('FIRST_USER_CAT', 10000);
		$amSettings['cpg_data_path'] = $amSettings['cpg_path'] . '/albums/';
	}

	// Load the steps
	// step => array(title, function, weight)
	$context['steps'] = array(
		0 => array('Begin conversion', 'BeginConvert', 0),
		1 => array('Load conversion data', 'LoadConvert', 5),
		2 => array('Empty gallery', 'EmptyGallery', 5),
		3 => array('Convert albums', 'ConvertAlbums', 20),
		4 => array('Convert items', 'ConvertItems', 45),
		5 => array('Convert comments', 'ConvertCom', 10),
		6 => array('Recount totals', 'Recount', 15),
		7 => array('Finish', 'Finish', 0),
	);

	// Get the current step
	$context['current_step'] = isset($_GET['step']) && $_GET['step'] >= 0 && $_GET['step'] <= max(array_keys($context['steps'])) ? $_GET['step'] : 0;

	// Just load the stuff!
	$context['overall_percentage'] = 0;
	$context['current_percentage'] = 0;
	foreach ($context['steps'] as $num => $step)
	{
		// Is it the current step?
		$context['steps'][$num]['is_current'] = $num == $context['current_step'];

		// Is it done?
		if ($num < $context['current_step'])
		{
			$context['steps'][$num]['is_done'] = true;
			$context['overall_percentage'] += $step[2];
		}
		else
			$context['steps'][$num]['is_done'] = false;

		// Is it pending?
		$context['steps'][$num]['is_pending'] = $num > $context['current_step'];
	}

	// Step checks
	$context['mgc_started'] = isset($amSettings['cpg_start']) ? $amSettings['cpg_start'] : time();

	// Call the function
	$context['steps'][$context['current_step']][1]();
}

// Let's show them a nice welcome page
function BeginConvert()
{
	global $amFunc, $context;

	// Sub template
	$context['sub_template'] = 'mg_converter_begin';

	// Add the started time
	updateAevaSetting('cpg_start', time());
}

// Load the data to get the conversion going
function LoadConvert()
{
	global $amFunc, $context, $CONFIG;

	// Is it not set?
	if (!isset($_POST['mg_submit']))
		convert_error('You have not entered the data required');

	// Let's check if coppermine exists in there
	if (!file_exists($_POST['cpg_path'] . '/include/config.inc.php'))
		convert_error('Coppermine was not found on the path you entered');

	// Looks like coppermine was found, let's get the data into the DB
	updateAevaSetting('cpg_conv_loaded', 1);
	updateAevaSetting('cpg_path', $_POST['cpg_path']);

	// Let's get prefix for coppermine
	require_once($_POST['cpg_path'] . '/include/config.inc.php');
	$cpg_prefix = $CONFIG['TABLE_PREFIX'];
	$cpg_prefix = '`'.$CONFIG['dbname'].'`.' . $CONFIG['TABLE_PREFIX'];

	// Let's get the statistics
	$request = $amFunc['db_query']("
		SELECT COUNT(*)
		FROM {$cpg_prefix}pictures
		GROUP BY pid",array(),__FILE__,__LINE__);
	$pics = $amFunc['db_num_rows']($request);
	$amFunc['db_free_result']($request);
	$request = $amFunc['db_query']("
		SELECT COUNT(*)
		FROM {$cpg_prefix}albums
		GROUP BY aid",array(),__FILE__,__LINE__);
	$albums = $amFunc['db_num_rows']($request);
	$request = $amFunc['db_query']("
		SELECT COUNT(*)
		FROM {$cpg_prefix}comments
		GROUP BY msg_id",array(),__FILE__,__LINE__);
	$coms = $amFunc['db_num_rows']($request);

	// Let's insert our stats into the DB
	updateAevaSetting('cpg_pics', (int) $pics);
	updateAevaSetting('cpg_albums', (int) $albums);
	updateAevaSetting('cpg_coms', (int) $coms);
	updateAevaSetting('cpg_converted_items', 0);
	updateAevaSetting('cpg_converted_coms', 0);
	updateAevaSetting('cpg_converted_albums', 0);

	// Sub template
	$context['sub_template'] = 'mgc_loadconvert';

	// Overall percentage
	$context['overall_percentage'] += $context['steps'][$context['current_step']][2];
}

// Empties out Aeva Media gallery for conversion
function EmptyGallery()
{
	global $amFunc, $amSettings, $context;
	// Empty out the gallery
	$amFunc['db_query']('
		TRUNCATE {db_prefix}aeva_media',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		TRUNCATE {db_prefix}aeva_albums',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		TRUNCATE {db_prefix}aeva_variables',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		DELETE FROM {db_prefix}aeva_files
		WHERE id_file > 4',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		ALTER TABLE {db_prefix}aeva_files AUTO_INCREMENT = 5',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		TRUNCATE {db_prefix}aeva_comments',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		TRUNCATE {db_prefix}aeva_log_media',array(),__FILE__,__LINE__);
	$amFunc['db_query']('
		TRUNCATE {db_prefix}aeva_log_ratings',array(),__FILE__,__LINE__);

	// Empty the directories
	deltree($amSettings['data_dir_path'].'/albums');
	deltree($amSettings['data_dir_path'].'/album_icons');

	if (function_exists('aeva_mkdir'))
	{
		aeva_mkdir('/albums', 0777);
		aeva_mkdir('/album_icons', 0777);
	}
	else
	{
		@mkdir($amSettings['data_dir_path'].'/albums', 0777);
		@mkdir($amSettings['data_dir_path'].'/album_icons', 0777);
	}

	$context['sub_template'] = 'mg_emptyGallery';
	$context['overall_percentage'] += $context['steps'][$context['current_step']][2];
}

// Convert the albums
function ConvertAlbums()
{
	global $amFunc, $amSettings, $context, $cpg_prefix;

	// Load the groups
	$groups = array(-1,0);
	$request = $amFunc['db_query']('
		SELECT ID_GROUP as id_group
		FROM {db_prefix}membergroups',array(),__FILE__,__LINE__);
	while ($row = $amFunc['db_fetch_assoc']($request))
		$groups[] = $row['id_group'];
	$amFunc['db_free_result']($request);

	// Perform the query to fetch it
	$request = $amFunc['db_query']("
		SELECT aid, title, description, category
		FROM {$cpg_prefix}albums
		LIMIT {int:start}, {int:limit}",array('start' => $_REQUEST['start'], 'limit' => 200),__FILE__,__LINE__);

	while ($row = $amFunc['db_fetch_assoc']($request))
	{
		if (isOverLoaded())
			break;

		$featured = $row['category'] > FIRST_USER_CAT ? 0 : 1;
		$album_of = $featured ? 0 : $row['category'] - FIRST_USER_CAT;

		// Insert it
		$amFunc['db_insert'](
			'{db_prefix}aeva_albums',
			array('id_album', 'name', 'description', 'featured', 'approved', 'album_of', 'access', 'icon'),
			array($row['aid'], conv_char($row['title'], 255), conv_char($row['description']), $featured, 1, $album_of, implode(',', $groups), 4),
			__FILE__,__LINE__);

		// Create the directory
		aeva_createAlbumDir($row['aid']);
		aeva_reorderAlbums();

		updateAevaSetting('cpg_converted_albums', $amSettings['cpg_converted_albums'] + 1);
	}
	$amFunc['db_free_result']($request);

	$context['is_halted'] = false;
	$context['sub_template'] = 'mg_convertalbums';
	$context['current_percentage'] = round((100 / $amSettings['cpg_albums']) * $amSettings['cpg_converted_albums'], 2);
	$context['overall_percentage'] += round(($context['steps'][$context['current_step']][2] / $amSettings['cpg_albums']) * $amSettings['cpg_converted_albums'], 2);
	if ($amSettings['cpg_converted_albums'] < $amSettings['cpg_albums'])
	{
		$context['is_halted'] = true;
		haltConversion($converter_url . '?step=' . $context['current_step'] . ';start=' . $amSettings['cpg_converted_albums']);
	}
}

function getExt($file)
{
	$filename = strrchr($file, '/') ? substr(strrchr($file, '/'), 1) : $file;

	if (strrchr($filename, '.') == true)
	{
		$ext = substr(strrchr($filename, '.'), 1);
	}
	elseif (strrchr($filename, '_'))
	{
		$ext_part = substr(strrchr($filename, '_'), 1);
		if (substr($ext_part, 0, 3) == 'ext')
			$ext = substr($ext_part, 3);
	}
	if (isset($ext))
		return strtolower($ext);
	else
		return false;
}

// Converts items
function ConvertItems()
{
	global $amFunc, $amSettings, $context, $cpg_prefix;

	$request = $amFunc['db_query']('
		SELECT MAX(id_media)
		FROM {db_prefix}aeva_media',
		array(),__FILE__,__LINE__);
	list($max_id) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	// Get pictures to convert. The first of the batch is the one following the last converted picture.
	$request = $amFunc['db_query']("
		SELECT p.pid, p.aid, p.filepath, p.filename, p.pic_rating, p.votes, p.ctime, p.keywords, p.approved, p.owner_id, p.title, p.caption, p.hits
		FROM {$cpg_prefix}pictures AS p
		WHERE p.pid > {int:maxmedia}
		ORDER BY p.pid ASC
		LIMIT {int:limit}",array('maxmedia' => (int) $max_id, 'limit' => 200),__FILE__,__LINE__);

	while ($row = $amFunc['db_fetch_assoc']($request))
	{
		if (isOverLoaded())
			break;

		// Approved?
		$approved = $row['approved'] == 'YES' ? 1 : 0;

		if ($row['title'] == '')
			$row['title'] = str_replace(array('.', '-', ';', '|', '_'), ' ', substr($row['filename'], 0, strlen($row['filename']) - strlen(getExt($row['filename'])) - 1));

		// Process the file
		$exifRequest = $amFunc['db_query']("
			SELECT exifData
			FROM {$cpg_prefix}exif
			WHERE filename = {string:filename}",
			array(
				'filename' => 'albums/' . $row['filepath'] . $row['filename'],
			),__FILE__,__LINE__);
		list($exifData) = $amFunc['db_fetch_row']($exifRequest);
		if (!empty($exifData))
		{
			$exifInfo = getInfo(unserialize($exifData));
			$exifData = serialize($exifInfo);
			if (isset($_REQUEST['exifdate']) && !empty($exifInfo['datetime']))
				if (preg_match('/(\d{4}).(\d{2}).(\d{2}) (\d{2}).(\d{2}).(\d{2})/', $exifInfo['datetime'], $dt) > 0)
					$row['ctime'] = mktime($dt[4], $dt[5], $dt[6], $dt[2], $dt[3], $dt[1]);
		}
		$amFunc['db_free_result']($exifRequest);

		// Create the file
		$options = array(
			'filepath' => $amSettings['cpg_data_path'] . $row['filepath'] . $row['filename'],
			'filename' => $row['filename'],
			'album' => $row['aid'],
			'destination' => aeva_getSuitableDir($row['aid']),
			'is_uploading' => false,
			'security_override' => true,
		);

		$ret = aeva_createFile($options);
		if (!is_array($ret))
		{
			$id_file = 3;
			$id_thumb = 3;
			$id_preview = 3;
		}
		else
		{
			$id_file = $ret['file'];
			$id_thumb = $ret['thumb'];
			$id_preview = $ret['preview'];

			// Update the exif
			if (!empty($id_file))
			{
				$amFunc['db_query']('
					UPDATE {db_prefix}aeva_files
					SET exif = {string:exif}
					WHERE id_file = {int:file}',
					array(
						'exif' => isset($exifData) ? str_replace("\0", ' ', $exifData) : '',
						'file' => $id_file,
					),__FILE__,__LINE__
				);
			}
		}

		// Create the item
		$amFunc['db_insert'](
			'{db_prefix}aeva_media',
			array('id_media', 'album_id', 'id_member', 'title', 'description', 'type', 'id_file', 'id_thumb', 'id_preview', 'rating', 'voters', 'keywords', 'approved', 'time_added', 'views'),
			array($row['pid'], $row['aid'], $row['owner_id'], conv_char($row['title'], 255), conv_char($row['caption']), 'image', $id_file, $id_thumb, $id_preview, ($row['rating'] / 2000) * $row['votes'], $row['votes'], implode(',',explode(' ', $row['keywords'])), $approved, $row['ctime'], $row['hits']),
			__FILE__,__LINE__,true);

		// Update it
		updateAevaSetting('cpg_converted_items', $amSettings['cpg_converted_items'] + 1);
	}
	$amFunc['db_free_result']($request);

	$context['is_halted'] = false;
	$context['sub_template'] = 'mg_convertitems';
	$context['current_percentage'] = round((100 / $amSettings['cpg_pics']) * $amSettings['cpg_converted_items'], 2);
	$context['overall_percentage'] += round(($context['steps'][$context['current_step']][2] / $amSettings['cpg_pics']) * $amSettings['cpg_converted_items'], 2);
	if ($amSettings['cpg_converted_items'] < $amSettings['cpg_pics'])
	{
		$context['is_halted'] = true;
		haltConversion($converter_url . '?step=' . $context['current_step'] . ';done=' . $amSettings['cpg_converted_items']);
	}
}

function ConvertCom()
{
	global $context, $amSettings, $cpg_prefix, $converter_url, $amFunc;

	$request = $amFunc['db_query']("
		SELECT c.pid, c.msg_id, c.author_id, c.msg_body, c.msg_date, p.aid
		FROM {$cpg_prefix}comments AS c
			LEFT JOIN {$cpg_prefix}pictures AS p ON (p.pid = c.pid)
		ORDER BY c.msg_id ASC
		LIMIT {int:start}, {int:limit}", array('start' => $_REQUEST['start'], 'limit' => 200), __FILE__, __LINE__);

	while ($row = $amFunc['db_fetch_assoc']($request))
	{
		if (isOverLoaded())
			break;
		if (preg_match('/(\d{4}).(\d{2}).(\d{2}) (\d{2}).(\d{2}).(\d{2})/', $row['msg_date'], $dt) > 0)
			$timestamp = mktime($dt[4], $dt[5], $dt[6], $dt[2], $dt[3], $dt[1]);
		else
			$timestamp = 0;

		// Insert it if it really exists in the first place
		if ((int) $row['aid'] > 0)
			$amFunc['db_insert'](
				'{db_prefix}aeva_comments',
				array('id_comment', 'id_media', 'id_member', 'id_album', 'message', 'posted_on', 'approved'),
				array($row['msg_id'], $row['pid'], $row['author_id'], (int) $row['aid'], conv_char($row['msg_body']), $timestamp, 1),
				__FILE__,__LINE__
			);
		updateAevaSetting('cpg_converted_coms', $amSettings['cpg_converted_coms'] + 1);
	}
	$amFunc['db_free_result']($request);

	$context['is_halted'] = false;
	$context['sub_template'] = 'mg_convertcoms';
	$context['current_percentage'] = round((100 / $amSettings['cpg_coms']) * $amSettings['cpg_converted_coms'], 2);
	$context['overall_percentage'] += round(($context['steps'][$context['current_step']][2] / $amSettings['cpg_coms']) * $amSettings['cpg_converted_coms'], 2);
	if ($amSettings['cpg_converted_coms'] < $amSettings['cpg_coms'])
	{
		$context['is_halted'] = true;
		haltConversion($converter_url . '?step=' . $context['current_step'] . ';start=' . $amSettings['cpg_converted_coms']);
	}
}

// Recount totals
function Recount()
{
	global $amFunc, $context, $sourcedir;

	require_once($sourcedir . '/Aeva-Admin2.php');
	aeva_admin_maintenance_recount();

	$context['sub_template'] = 'mgc_recount';
	$context['overall_percentage'] += $context['steps'][$context['current_step']][2];
}

function DeleteTempSettings($settings)
{
	global $amFunc;

	foreach ($settings as $setting)
		$amFunc['db_query']('
			DELETE FROM {db_prefix}aeva_settings
			WHERE name = {string:name}', array('name' => $setting),__FILE__,__LINE__);
}

// We are done! :D
function Finish()
{
	global $context;

	DeleteTempSettings(array(
		'cpg_start', 'cpg_conv_loaded', 'cpg_path', 'cpg_pics', 'cpg_albums',
		'cpg_coms', 'cpg_converted_items', 'cpg_converted_coms', 'cpg_converted_albums'));

	$context['sub_template'] = 'mgc_finish';
}

function sanitize_data(&$value, $key)
{
	if (is_array($value))
	{
		array_walk($value, 'sanitize_data');
	} else
	{
		# sanitize against sql/html injection; trim any nongraphical non-ASCII character:
		$value = trim(htmlentities(strip_tags(trim($value,"\x7f..\xff\x0..\x1f")),ENT_QUOTES));
	}
}

// Updates a setting
function updateAevaSetting($name, $value)
{
	global $amFunc, $amSettings;

	$amFunc['db_query']('
		REPLACE INTO {db_prefix}aeva_settings
		(name, value)
		VALUES
		({string:name}, {string:value})',
		array(
			'name' => $name,
			'value' => $value,
		),__FILE__,__LINE__
	);
	$amSettings[$name] = $value;
}

// Shows an error
function convert_error($msg)
{
	global $context;
	$context['sub_template'] = 'mgc_error';
	$context['converter_msg'] = $msg;
	// Exit to prevent further execution
	obExit();
}
function template_mgc_error()
{
	global $context;
	echo '
		<div class="titlebg mgc_error">Error</div>
		<div class="windowbg2" style="padding: 10px;">
			',$context['converter_msg'],'<br />
			<div style="text-align: center; margin-top: 15px;"><a href="javascript:history.go(-1)">Back</a></div>
		</div>';
}
function isOverLoaded()
{
	global $context, $time_start;
	$load_time = round(array_sum(explode(' ', microtime())) - array_sum(explode(' ', $time_start)), 3);

	if ($load_time >= $context['max_exec'])
		return true;
	return false;
}
function haltConversion($url)
{
	global $context;
	$context['html_headers'] = '
		<meta http-equiv="refresh" content="' . $context['wait_time'] . '; url=' . $url . (isset($_REQUEST['exifdate']) ? ';exifdate' : '') . '" />';
	obExit();
}
function conv_char($text, $limit = 0)
{
	return aeva_utf2entities($text, false, $limit);
}
function template_mg_converter_above()
{
	global $settings, $scripturl, $txt, $context, $amSettings;

	header('Content-Type: text/html;');

	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"', !empty($txt['lang_rtl']) ? ' dir="rtl"' : '', '>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
		<title>Aeva Media gallery converter</title>', $context['html_headers'], '
		<link rel="stylesheet" type="text/css" href="', $settings['default_theme_url'] , '/style.css" />
		<style type="text/css">
			div#header
			{
				background-image: url(Themes/default/images/catbg.jpg);
				background-repeat: repeat-x;
				background-color: #88A6C0;
				padding: 22px 4% 12px 4%;
				color: white;
				font-family: Georgia, serif;
				font-size: xx-large;
				border-bottom: 1px solid black;
				height: 40px;
			}
			.stepdone
			{
				color: darkgreen;
				font-size: xx-small;
			}
			.stepcurrent
			{
				color: darkblue;
				font-size: xx-small;
				font-weight: bold;
			}
			.stepwaiting
			{
				color: black;
				font-size: xx-small;
			}
			.smalltext
			{
				font-size: x-small;
				font-family: verdana, sans-serif;
			}
			.mgc_error
			{
				font-size: large;
				text-align: center;
				font-weight: bold;
				color: red;
				padding: 6px;
			}
			.footer
			{
				text-align: center;
				font-size: x-small;
			}
			.loadtime
			{
				text-align: center;
				font-size: x-small;
			}
		</style>
	</head>
	<body>
		<div id="header">
			<div title="Moogle Express!">Aeva Media gallery converter</div>
		</div>
		<div id="content">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" style="padding-top: 1ex;">
				<tr>
					<td width="200" valign="top" style="padding-right: 10px;">
						<table border="0" cellpadding="8" cellspacing="0" class="tborder" width="200">
							<tr>
								<td class="titlebg">Steps</td>
							</tr>
							<tr>
								<td class="windowbg2">';

	if (!empty($context['steps']))
		foreach ($context['steps'] as $s)
			echo '<span class="',$s['is_current'] ? 'stepcurrent' : ($s['is_done'] ? 'stepdone' : 'stepwaiting'),'">',$s[0],'</span><br />';

	echo '
								</td>
							</tr>
							<tr>
								<td class="titlebg">Progress</td>
							</tr>
							<tr>
								<td class="windowbg2">
									<div class="smalltext" style="text-align: center; padding: 3px 3px 6px 3px;">Overall progress:</div>
									<div style="font-size: 8pt; height: 12pt; border: 1px solid black; background-color: white; position: relative;">
										<div id="overall_text" style="padding-top: 1pt; width: 100%; z-index: 2; color: black; position: absolute; text-align: center; font-weight: bold;">', $context['overall_percentage'], '%</div>
										<div id="overall_progress" style="width: ', $context['overall_percentage'], '%; height: 12pt; z-index: 1; background-color: yellow;">&nbsp;</div>
									</div>';

	if (!empty($context['current_percentage']))
		echo '
										<div class="smalltext" style="text-align: center; padding: 3px 3px 6px 3px;">Current step progress:</div>
										<div style="font-size: 8pt; height: 12pt; border: 1px solid black; background-color: white; position: relative;">
											<div id="overall_text" style="padding-top: 1pt; width: 100%; z-index: 2; color: black; position: absolute; text-align: center; font-weight: bold;">', $context['current_percentage'], '%</div>
											<div id="overall_progress" style="width: ', $context['current_percentage'], '%; height: 12pt; z-index: 1;  background-color: #EEBAF4;">&nbsp;</div>
										</div>';

	// Get the total time executed
	$total_executed = time() - $amSettings['cpg_start'];
	$mins = (int) ($total_executed / 60);
	$seconds = $total_executed - $mins * 60;

	echo '
										<div class="smalltext" style="padding: 5px; text-align: center;">Total time elapsed:</div>
										<div class="smalltext" style="color: blue; text-align: center;"><span id="mins_elapsed">', $mins, '</span> minutes, <span id="secs_elapsed">', $seconds, '</span> seconds.</div>';
	echo '
								</td>
							</tr>
						</table>
					</td>
					<td width="100%" valign="top">';
}

// Template of welcome page
function template_mg_converter_begin()
{
	global $context, $amSettings, $converter_url;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Welcome</td>
			</tr>
			<tr class="windowbg2">
				<td>
					Welcome to the Coppermine converter for Aeva Media, and thank you for trying out Aeva Media.<br /><br />This converter in simple steps will convert your Coppermine Gallery database to Aeva Media. Time taken will depend on the size of your database.<br /><br />
					Make sure that Coppermine is integrated and working properly with SMF. This converter will NOT work with unbridged versions of Coppermine.<br /><br />
					<div style="font-weight: bold; font-size: 13px;">Please Note: Your Aeva Media installation will be cleaned up, meaning all albums, items, comments etc. will be deleted, before converting. However, Your Coppermine Gallery will remain unchanged.</div><br /><br /><br />

					<form action="',$converter_url,'?step=',$context['current_step'] + 1,'" method="post">
						Enter exact path to your Coppermine install: <input type="text" size="30" name="cpg_path" /><br />
						<input type="checkbox" name="exifdate" /> Use original Exif picture date for item dates whenever available.
						<div style="text-align: center;"><input type="submit" name="mg_submit" value="Next" /></div>
					</form>
				</td>
			</tr>
		</table>';
}
function template_mgc_loadconvert()
{
	global $context, $amSettings, $converter_url;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Load conversion data</td>
			</tr>
			<tr class="windowbg2">
				<td>
					Coppermine was found on the path you entered<br /><br />
					Here are the stats gathered :<br />
					Total items : ',$amSettings['cpg_pics'],'<br />
					Total comments : ',$amSettings['cpg_coms'],'<br />
					Total albums : ',$amSettings['cpg_albums'],'<br /><br />
					<div style="text-align: right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1, isset($_REQUEST['exifdate']) ? ';exifdate' : '', '">Next</a></div>
				</td>
			</tr>
		</table>';
}
function template_mg_emptyGallery()
{
	global $converter_url, $context;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Empty gallery</td>
			</tr>
			<tr class="windowbg2">
				<td>The gallery has been cleaned and can now be converted.<div style="text-align: right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,isset($_REQUEST['exifdate']) ? ';exifdate' : '', '">Next</a></div></td>
			</tr>
		</table>';
}
// Template of conversion of albums
function template_mg_convertalbums()
{
	global $converter_url, $context;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert albums</td>
			</tr>
			<tr class="windowbg2">
				<td>';
		if ($context['is_halted'])
			echo '
				<div>Conversion has been halted, it will automatically resume in ',$context['wait_time'],' second(s).</div>';
		else
			echo '
				<div>Conversion of albums has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,isset($_REQUEST['exifdate']) ? ';exifdate' : '', '">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}

// Template for item converter
function template_mg_convertitems()
{
	global $converter_url, $context, $amSettings;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert items</td>
			</tr>
			<tr class="windowbg2">
				<td>';
		if ($context['is_halted'])
			echo '
					The conversion has been halted to avoid overloading your server. So far, ', $amSettings['cpg_converted_items'], ' items out of ', $amSettings['cpg_pics'],' have been converted. The script will automatically resume in ',$context['wait_time'],' second(s).';
		else
			echo '
				<div>Conversion of items has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}

// Template for comment converter
function template_mg_convertcoms()
{
	global $converter_url, $context, $amSettings;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert comments</td>
			</tr>
			<tr class="windowbg2">
				<td>';
	if ($context['is_halted'])
		echo '
					The conversion has been halted to avoid overloading your server. So far, ', $amSettings['cpg_converted_coms'], ' reports out of ', $context['cpg_coms'],' have been converted. The script will automatically resume in ',$context['wait_time'],' second(s).';
	else
		echo '
				<div>Conversion of comments has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}

// Recount totals
function template_mgc_recount()
{
	global $converter_url, $context;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Recount statistics</td>
			</tr>
			<tr class="windowbg2">
				<td>
					<div>The Recount maintenance task has been successfully executed.</div>
					<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>
				</td>
			</tr>
		</table>';
}

// Finish
function template_mgc_finish()
{
	global $context, $galurl, $galurl2, $scripturl;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Finished</td>
			</tr>
			<tr class="windowbg2">
				<td>
					The converter has finished converting Coppermine to Aeva Media<br /><br />
					<a href="'.$scripturl.'">Go to your forum</a><br />
					<a href="'.$galurl2.'">Go to your newly converted gallery</a><br /><br />
					<b>It is recommended to remove this converter</b>
				</td>
			</tr>
			<tr>
				<td>';

	if (is_writable(dirname(__FILE__)) || is_writable(__FILE__))
		echo '
					<label for="delete_self"><input type="checkbox" id="delete_self" onclick="doTheDelete(this);" /> Delete this file.</label> <i>(doesn\'t work on all servers.)</i>
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						function doTheDelete(theCheck)
						{
							var theImage = document.getElementById ? document.getElementById("delete_upgrader") : document.all.delete_upgrader;

							theImage.src = "', $_SERVER['PHP_SELF'], '?delete=1&ts_" + (new Date().getTime());
							theCheck.disabled = true;
						}
					// ]]></script>
					<img src="', $boardurl, '/Themes/default/images/blank.gif" alt="" id="delete_upgrader" />';

	echo '
				</td>
			</tr>
		</table>';
}

// The below template of converter
function template_mg_converter_below()
{
	global $time_start, $context, $db_count, $amSettings;
	echo '
					</td>
				</tr>
			</table>
			<div class="footer">
				Aeva Media '.$amSettings['version'].' &copy; <a href="http://noisen.com/">noisen</a> / <a href="http://smf-media.com">smf-media</a>
			</div>
			<div class="loadtime">
				Page loaded in ',round(array_sum(explode(' ', microtime())) - array_sum(explode(' ', $time_start)), 3),' seconds with '.$db_count.' queries
			</div>
		</div>
	</body>
</html>';
}

function getInfo($data)
{
	global $sourcedir;

	$return = array();

	if (isset($data['IFD0']['DateTime']))		$return['datetime'] = $data['IFD0']['DateTime'];
	if (isset($data['COMPUTED']['Copyright']))	$return['copyright'] = $data['COMPUTED']['Copyright'];
	if (isset($data['IFD0']['Make']))			$return['make'] = $data['IFD0']['Make'];
	if (isset($data['IFD0']['Model']))			$return['model'] = $data['IFD0']['Model'];
	if (isset($data['SubIFD']['Flash']))		$return['flash'] = $data['SubIFD']['Flash'];
	if (isset($data['SubIFD']['ExposureTime']))	$return['xposuretime'] = $data['SubIFD']['ExposureTime'];
	if (isset($data['IFD0']['Orientation']))	$return['orientation'] = $data['IFD0']['Orientation'];
	if (isset($data['SubIFD']['FocalLength']))	$return['focal_length'] = $data['SubIFD']['FocalLength'];
	if (isset($data['IFD0']['xResolution']))	$return['xres'] = $data['IFD0']['xResolution'];
	if (isset($data['IFD0']['yResolution']))	$return['yres'] = $data['IFD0']['yResolution'];
	if (isset($data['IFD0']['ResolutionUnit']))	$return['resunit'] = $data['IFD0']['ResolutionUnit'];
	if (isset($data['SubIFD']['FNumber']))		$return['fnumber'] = $data['SubIFD']['FNumber'];
	if (isset($data['SubIFD']['MakerNote']['Settings 1']['ISO'])) $return['iso'] = $data['SubIFD']['MakerNote']['Settings 1']['ISO'];
	if (isset($data['SubIFD']['MakerNote']['Settings 1']['MeteringMode'])) $return['meteringMode'] = $data['SubIFD']['MakerNote']['Settings 1']['MeteringMode'];
	if (isset($data['SubIFD']['MakerNote']['Settings 1']['DigitalZoom'])) $return['digitalZoom'] = $data['SubIFD']['MakerNote']['Settings 1']['DigitalZoom'];
	if (isset($data['SubIFD']['MakerNote']['Settings 1']['Contrast'])) $return['contrast'] = $data['SubIFD']['MakerNote']['Settings 1']['Contrast'];
	if (isset($data['SubIFD']['MakerNote']['Settings 1']['Sharpness'])) $return['sharpness'] = $data['SubIFD']['MakerNote']['Settings 1']['Sharpness'];
	if (isset($data['SubIFD']['MakerNote']['Settings 1']['FocusType'])) $return['focusType'] = $data['SubIFD']['MakerNote']['Settings 1']['FocusType'];
	if (isset($data['SubIFD']['ExifVersion'])) $return['exifVersion'] = $data['SubIFD']['ExifVersion'];

	if (isset($return['xres']) && isset($return['resunit']))
	{
		if ($return['resunit'] == 'Inch')
			$return['xres'] = str_replace('dots per ResolutionUnit', 'dpi', $return['xres']);
		else
			$return['xres'] = str_replace('ResolutionUnit', $return['resunit'], $return['xres']);
	}
	if (isset($return['yres']) && isset($return['resunit']))
	{
		if ($return['resunit'] == 'Inch')
			$return['yres'] = str_replace('dots per ResolutionUnit', 'dpi', $return['yres']);
		else
			$return['yres'] = str_replace('ResolutionUnit', $return['resunit'], $return['yres']);
	}

	// Return it now
	return $return;
}

?>