<?php
/****************************************************************
* Converter for Aeva Media 1.0									*
*  Noisen.com & SMF-Media.com									*
*****************************************************************
* mgconverter_sgp.php - Converts SMF Gallery Pro to Aeva Media	*
*****************************************************************
* Users of this software are bound by the terms of the			*
* Aeva Media license. You can view it in the license_am.txt		*
* file, or online at http://noisen.com/license.php				*
*																*
* Support and updates for this software can be found at			*
* http://aeva.noisen.com and http://smf-media.com				*
****************************************************************/

$path_to_ssi = dirname(__FILE__) . '/SSI.php';
if (file_exists($path_to_ssi))
	require_once($path_to_ssi);
else
	die('SSI.php was not found');

global $sourcedir, $context, $txt;

$context['template_layers'] = array();
$context['template_layers'] = array('mg_converter');

// You can set these to higher numbers if your server can handle the load.
$context['max_exec'] = 5;
$context['wait_time'] = 1;

// The whole "delete" part was copied from the SMF code. Thanks, guys!
if (isset($_GET['delete']))
{
	@unlink(__FILE__);

	header('Location: http://' . (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT']) . dirname($_SERVER['PHP_SELF']) . '/Themes/default/images/blank.gif');
	exit;
}

// Initialize the conversion
initConverter();

obExit();

// Loads the converter
function initConverter()
{
	global $converter_url, $sourcedir, $context, $amFunc, $boardurl, $boarddir, $modSettings;

	// The converter's URL
	$converter_url = $_SERVER['PHP_SELF'];

	// Call Aeva-Subs.php and load deltree function
	require_once($sourcedir . '/Aeva-Subs.php');
	require_once($sourcedir . '/Subs-Package.php');
	// Load the gallery
	aeva_loadSettings(null, false, true);

	// Are you allowed to convert?
	if (!aeva_allowedTo('manage'))
		converterError('You are not allowed to make the conversion');

	// Load the steps
	// step => array(title, function, weight)
	$context['steps'] = array(
		0 => array('Begin conversion', 'Welcome', 0),
		1 => array('Load conversion', 'LoadConversion', 5),
		2 => array('Convert categories', 'ConvertCats', 20),
		3 => array('Convert items', 'ConvertItems', 40),
		4 => array('Convert comments', 'ConvertComs', 15),
		5 => array('Convert reports', 'ConvertReports', 5),
		6 => array('Recount statistics', 'Recount', 15),
		7 => array('Finish', 'Finish', 0),
	);

	// Get the current step
	$context['current_step'] = isset($_GET['step']) && $_GET['step'] >= 0 && $_GET['step'] <= max(array_keys($context['steps'])) ? $_GET['step'] : 0;

	// Just load the stuff!
	$context['overall_percentage'] = 0;
	$context['current_percentage'] = 0;
	foreach ($context['steps'] as $num => $step)
	{
		// Is it the current step?
		$context['steps'][$num]['is_current'] = $num == $context['current_step'];

		// Is it done?
		if ($num < $context['current_step'])
		{
			$context['steps'][$num]['is_done'] = true;
			$context['overall_percentage'] += $step[2];
		}
		else
			$context['steps'][$num]['is_done'] = false;

		// Is it pending?
		$context['steps'][$num]['is_pending'] = $num > $context['current_step'];
	}

	// Step checks
	$_SESSION['mgc_last_step'] = isset($_SESION['mgc_last_step']) ? $_SESSION['mgc_last_step'] : 0;

	// Is it SMF 2?
	if ($context['is_smf2'])
		$context['is_gallery2'] = true;

	if (empty($context['current_step']))
		$_SESSION['mgc_started'] = time();

	$context['mgc_start'] = isset($_SESSION['mgc_started']) ? $_SESSION['mgc_started'] : time();

	if (!isset($modSettings['gallery_path']))
		$modSettings['gallery_path'] = $boarddir . '/gallery/';

	// Call the function
	$context['steps'][$context['current_step']][1]();
}
function Welcome()
{
	global $context, $user_info, $amFunc, $scripturl, $db_name, $db_prefix, $curr_url, $amSettings;

	// Is SMG installed?
	$request = $amFunc['db_query']("SHOW TABLES FROM `$db_name`", array(), __FILE__,__LINE__);
	$found = false;
	while ($row = $amFunc['db_fetch_row']($request))
		if (('`'.$db_name.'`.'.$row[0] == $db_prefix . 'gallery_pic') || ($db_name.'.'.$row[0] == $db_prefix . 'gallery_pic') || ($row[0] == $db_prefix . 'gallery_pic'))
			$found = true;
	$amFunc['db_free_result']($request);

	// Nope? Then leave.
	if (!$found)
		converterError('SMF Gallery Pro wasn\'t found on this server');

	// Get the statistics to convert
	$request = convert_query('
		SELECT COUNT(*)
		FROM {db_prefix}gallery_pic',
		array(),
		__FILE__,__LINE__);
	list($num_items) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	$request = convert_query('
		SELECT COUNT(*), MAX(ID_CAT)
		FROM {db_prefix}gallery_cat',
		array(),
		__FILE__,__LINE__);
	list($num_cats, $last_general_cat) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	$request = convert_query('
		SELECT COUNT(*)
		FROM {db_prefix}gallery_usercat',
		array(),
		__FILE__,__LINE__);
	list($user_cat) = $amFunc['db_fetch_row']($request);
	$num_cats += (int) $user_cat;
	$amFunc['db_free_result']($request);

	$request = convert_query('
		SELECT COUNT(ID_COMMENT)
		FROM {db_prefix}gallery_comment',
		array(),
		__FILE__,__LINE__);
	list($num_coms) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	$request = convert_query('
		SELECT COUNT(ID)
		FROM {db_prefix}gallery_report',
		array(),
		__FILE__,__LINE__);
	list($num_report) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	aeva_updateSettings('sgp_total_items', (int) $num_items, true);
	aeva_updateSettings('sgp_total_cats', (int) $num_cats, true);
	aeva_updateSettings('sgp_total_coms', (int) $num_coms, true);
	aeva_updateSettings('sgp_total_reports', (int) $num_report, true);
	aeva_updateSettings('sgp_last_gen', (int) $last_general_cat, true);

	// Assign it to the globals for template
	$context += array(
		'mgc_num_items' => (int) $num_items,
		'mgc_num_coms' => (int) $num_coms,
		'mgc_num_reports' => (int) $num_report,
		'mgc_num_cats' => (int) $num_cats,
	);

	// Sub-Template
	$context['sub_template'] = 'mgc_welcome';
}

// Makes the gallery fit for conversion
function LoadConversion()
{
	global $amSettings, $context;
	// Empty out the gallery
	convert_query('
		TRUNCATE {db_prefix}aeva_media',array(),__FILE__,__LINE__);
	convert_query('
		TRUNCATE {db_prefix}aeva_albums',array(),__FILE__,__LINE__);
	convert_query('
		TRUNCATE {db_prefix}aeva_variables',array(),__FILE__,__LINE__);
	convert_query('
		DELETE FROM {db_prefix}aeva_files
		WHERE id_file > 4',array(),__FILE__,__LINE__);
	convert_query('
		ALTER TABLE {db_prefix}aeva_files AUTO_INCREMENT = 5',array(),__FILE__,__LINE__);
	convert_query('
		TRUNCATE {db_prefix}aeva_comments',array(),__FILE__,__LINE__);
	convert_query('
		TRUNCATE {db_prefix}aeva_log_media',array(),__FILE__,__LINE__);
	convert_query('
		TRUNCATE {db_prefix}aeva_log_ratings',array(),__FILE__,__LINE__);

	// Empty the directories
	deltree($amSettings['data_dir_path'].'/albums');
	deltree($amSettings['data_dir_path'].'/album_icons');

	if (function_exists('aeva_mkdir'))
	{
		aeva_mkdir('/albums', 0777);
		aeva_mkdir('/album_icons', 0777);
	}
	else
	{
		@mkdir($amSettings['data_dir_path'].'/albums', 0777);
		@mkdir($amSettings['data_dir_path'].'/album_icons', 0777);
	}

	aeva_updateSettings('sgp_converted_items', 0, true);
	aeva_updateSettings('sgp_converted_cats', 0, true);
	aeva_updateSettings('sgp_converted_reports', 0, true);
	aeva_updateSettings('sgp_converted_coms', 0, true);

	$context['sub_template'] = 'mgc_loadconversion';
	$context['overall_percentage'] += $context['steps'][$context['current_step']][2];
}
// Convert categories
function ConvertCats()
{
	global $modSettings, $amSettings, $amFunc, $context;

	// Load the groups
	$groups = array(-1,0);
	$request = convert_query('
		SELECT ID_GROUP as id_group
		FROM {db_prefix}membergroups',array(),__FILE__,__LINE__);
	while ($row = $amFunc['db_fetch_assoc']($request))
		$groups[] = $row['id_group'];
	$amFunc['db_free_result']($request);

	// Is it halted?
	$context['is_halted'] = false;

	// Get the max cat id
	$request = convert_query('
		SELECT MAX(id_album)
		FROM {db_prefix}aeva_albums',
		array(),
		__FILE__,__LINE__);
	list($last_cat) = $amFunc['db_fetch_row']($request);
	$last_cat = (int) $last_cat;
	$amFunc['db_free_result']($request);

	$skip_conversion = false;
	// Perform the query to get the categories
	if ($last_cat <= $amSettings['sgp_last_gen'])
		$request = convert_query('
			SELECT ID_CAT AS id, title, description, ID_PARENT as id_parent, 0 AS id_member
			FROM {db_prefix}gallery_cat
			WHERE ID_CAT > {int:last_cat}
			ORDER BY ID_CAT
			LIMIT 250',
			array('last_cat' => $last_cat),__FILE__,__LINE__);
	else
		$request = convert_query('
			SELECT USER_ID_CAT+' . $amSettings['sgp_last_gen'] . ' AS id, title, description, IF(ID_PARENT=0,0,ID_PARENT+' . $amSettings['sgp_last_gen'] . ') AS id_parent, ID_MEMBER AS id_member
			FROM {db_prefix}gallery_usercat
			WHERE USER_ID_CAT > {int:last_cat}
			ORDER BY USER_ID_CAT
			LIMIT 250',
			array('last_cat' => (int) ($last_cat - $amSettings['sgp_last_gen'])),__FILE__,__LINE__);
	// Are general albums all converted? Then do user albums...
	if ($amFunc['db_num_rows']($request) == 0)
	{
		if ($last_cat <= $amSettings['sgp_last_gen'])
			$request = convert_query('
				SELECT USER_ID_CAT+' . $amSettings['sgp_last_gen'] . ' AS id, title, description, IF(ID_PARENT=0,0,ID_PARENT+' . $amSettings['sgp_last_gen'] . ') AS id_parent, ID_MEMBER AS id_member
				FROM {db_prefix}gallery_usercat
				ORDER BY USER_ID_CAT
				LIMIT 250', array(), __FILE__,__LINE__);
		else
			$skip_conversion = true;
	}
	$context['converted_cats'] = array();

	if (!$skip_conversion)
		while ($row = $amFunc['db_fetch_assoc']($request))
		{
			if (isOverLoaded())
				break;

			// Create the DB entry for this item
			$amFunc['db_insert'](
				'{db_prefix}aeva_albums',
				array('id_album', 'name', 'description', 'parent', 'featured', 'album_of', 'approved', 'access', 'icon'),
				array($row['id'], $row['title'], $row['description'], $row['id_parent'], $row['id'] > $amSettings['sgp_last_gen'] ? 0 : 1, $row['id_member'], 1, implode(',', $groups), 4),
				__FILE__,__LINE__);
			$id_album  = $amFunc['db_insert_id']();

			// End it :D
			aeva_createAlbumDir($id_album);
			aeva_reorderAlbums();
			aeva_updateSettings('sgp_converted_cats', $amSettings['sgp_converted_cats'] + 1);
			$context['converted_cats'][] = $row['title'];
		}
		$amFunc['db_free_result']($request);

	// How much are we done?
	$context['current_percentage'] = round((100 / $amSettings['sgp_total_cats']) * $amSettings['sgp_converted_cats'], 2);
	$context['overall_percentage'] += round(($context['steps'][$context['current_step']][2] / $amSettings['sgp_total_cats']) * $amSettings['sgp_converted_cats'], 2);

	$context['sub_template'] = 'mgc_convert_cats';

	if ($amSettings['sgp_converted_cats'] < $amSettings['sgp_total_cats'])
	{
		haltConversion($converter_url.'?step='.$context['current_step']);
		$context['is_halted'] = true;
	}
	else
	{
		$request = convert_query('SELECT id_album, parent, child_level FROM {db_prefix}aeva_albums', array(), __FILE__,__LINE__);
		$albums = array();
		while ($row = $amFunc['db_fetch_assoc']($request))
		{
			$id = $row['id_album'];
			$albums[$id] = $row;
			// Already updated?
			if ($albums[$id]['child_level'] > 0)
				unset($albums[$id]);
			else
				$albums[$id]['child_level'] = -1;
		}
		$amFunc['db_free_result']($request);

		$not_finished = true;
		while ($not_finished)
		{
			foreach ($albums as $id => $album)
				if ($album['parent'] == 0)
					$albums[$id]['child_level'] = 0;
				elseif ($albums[$album['parent']] >= 0 && $albums[$album['parent']]['child_level'] >= 0)
					$albums[$id]['child_level'] = $albums[$album['parent']]['child_level'] + 1;

			$not_finished = false;
			foreach ($albums as $album)
				if ($album['child_level'] < 0)
					$not_finished = true;
		}

		foreach ($albums as $album)
		{
			if (isOverLoaded())
			{
				haltConversion($converter_url.'?step='.$context['current_step']);
				$context['is_halted'] = true;
				break;
			}

			convert_query('
				UPDATE {db_prefix}aeva_albums
				SET child_level = {int:child}, parent = {int:parent}
				WHERE id_album = {int:album}',
				array(
					'child' => (int) $album['child_level'],
					'parent' => (int) $album['parent'],
					'album' => (int) $album['id_album']
				), __FILE__,__LINE__);
		}
	}
}

// The real part - Convert items
function ConvertItems()
{
	global $modSettings, $amSettings, $context, $converter_url, $amSettings, $amFunc;

	$context['is_halted'] = false;

	// Get the last item
	$request = convert_query('
		SELECT MAX(id_media)
		FROM {db_prefix}aeva_media',
		array(),__FILE__,__LINE__);
	list($last_item) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	// Load all the items
	$request = convert_query('
		SELECT
			ID_PICTURE AS id_picture, filename, thumbfilename, mediumfilename, date, title, ID_MEMBER AS id_member,
			approved, keywords, views, filesize, description, width, height, totalratings, rating,
			IF(ID_CAT>0,ID_CAT,USER_ID_CAT+' . $amSettings['sgp_last_gen'] . ') AS id_cat
		FROM {db_prefix}gallery_pic
		WHERE ID_PICTURE > {int:last_item}
		ORDER BY ID_PICTURE ASC
		LIMIT {int:limit}',
		array(
			'last_item' => (int) $last_item,
			'limit' => 250,
		),__FILE__,__LINE__);
	while ($row = $amFunc['db_fetch_assoc']($request))
	{
		if (isOverLoaded())
			break;

		$row['thumbfilename'] = empty($row['thumbfilename']) ? 'thumb_' . $row['filename'] : $row['thumbfilename'];
		$row['mediumfilename'] = empty($row['mediumfilename']) ? 'preview_' . $row['filename'] : $row['mediumfilename'];
		$row['title'] = !empty($row['title']) ? $row['title'] : '...';

		// Get the file
		$cat_dir = aeva_getSuitableDir($row['id_cat']);
		$curr_path = $modSettings['gallery_path'].$row['filename'];
		$curr_thumb_path = $modSettings['gallery_path'].$row['thumbfilename'];
		$curr_preview_path = $modSettings['gallery_path'].$row['mediumfilename'];

		// Create the file
		$fopts = array(
			'filepath' => $curr_path,
			'filename' => $row['filename'],
			'skip_thumb' => file_exists($curr_thumb_path),
			'skip_preview' => file_exists($curr_preview_path),
			'destination' => $cat_dir,
			'security_override' => true,
			'is_uploading' => false,
			'album' => $row['id_cat'],
		);
		$pos = strrpos($row['filename'], '/');
		if ($pos !== false)
			$fopts['filename'] = substr($fopts['filename'], $pos + 1);

		$ret = aeva_createFile($fopts);

		$id_file = $ret['file'];
		$id_thumb = isset($ret['thumb']) ? $ret['thumb'] : 0;
		$id_preview = isset($ret['preview']) ? $ret['preview'] : 0;

		// If the thumbnail returned is empty, then we need to move the existing one
		if (empty($id_thumb))
		{
			$topts = array(
				'filepath' => $curr_thumb_path,
				'filename' => $row['thumbfilename'],
				'skip_thumb' => true,
				'skip_preview' => true,
				'destination' => $cat_dir,
				'security_override' => true,
				'is_uploading' => false,
				'album' => $row['id_cat'],
			);
			$pos = strrpos($row['thumbfilename'], '/');
			if ($pos !== false)
				$topts['filename'] = substr($topts['filename'], $pos + 1);

			$ret = aeva_createFile($topts);
			$id_thumb = $ret['file'];
		}

		// If the preview returned is empty, then we need to move the existing one
		if (empty($id_preview))
		{
			$popts = array(
				'filepath' => $curr_preview_path,
				'filename' => $row['mediumfilename'],
				'skip_thumb' => true,
				'skip_preview' => true,
				'destination' => $cat_dir,
				'security_override' => true,
				'is_uploading' => false,
				'album' => $row['id_cat'],
			);
			$pos = strrpos($row['mediumfilename'], '/');
			if ($pos !== false)
				$popts['filename'] = substr($popts['filename'], $pos + 1);

			$ret = aeva_createFile($popts);
			$id_preview = $ret['file'];
		}

		// Insert the actual item
		$amFunc['db_insert'](
			'{db_prefix}aeva_media',
			array(
				'id_media', 'title', 'description', 'id_file', 'id_thumb', 'id_preview', 'views',
				'rating', 'voters', 'keywords', 'approved', 'time_added', 'album_id', 'type', 'id_member'),
			array(
				$row['id_picture'], $row['title'], (string) $row['description'], $id_file, $id_thumb, $id_preview, $row['views'],
				$row['rating'], $row['totalratings'], (string) $row['keywords'], 1, $row['date'], $row['id_cat'], 'image', $row['id_member']),
			__FILE__,__LINE__,true);

		aeva_updateSettings('sgp_converted_items', $amSettings['sgp_converted_items'] + 1);
	}
	$amFunc['db_free_result']($request);

	// Sub-Template
	$context['sub_template'] = 'mgc_convert_items';

	// How much are we done?
	$context['current_percentage'] = round((100 / $amSettings['sgp_total_items']) * $amSettings['sgp_converted_items'], 2);
	$context['overall_percentage'] += round(($context['steps'][$context['current_step']][2] / $amSettings['sgp_total_items']) * $amSettings['sgp_converted_items'], 2);

	if ($amSettings['sgp_converted_items'] < $amSettings['sgp_total_items'])
	{
		$context['is_halted'] = true;
		haltConversion($converter_url.'?step='.$context['current_step']);
	}
}

// Converts comment
function ConvertComs()
{
	global $converter_url, $context, $amFunc, $amSettings;

	$context['sub_template'] = 'mgc_convert_coms';
	$context['is_halted'] = false;

	// Load the comments
	// 1k at a time
	// Get the last one
	$request = convert_query('
		SELECT MAX(id_comment)
		FROM {db_prefix}aeva_comments',
		array(),__FILE__,__LINE__);
	list($last_com) = $amFunc['db_fetch_row']($request);
	$amFunc['db_free_result']($request);

	$request = convert_query("
		SELECT c.ID_COMMENT AS id_comment, c.ID_MEMBER AS id_member, c.date, c.approved, c.comment, c.ID_PICTURE AS id_pic, p.ID_CAT AS id_cat
		FROM {db_prefix}gallery_comment AS c
			LEFT JOIN {db_prefix}gallery_pic AS p ON (p.ID_PICTURE = c.ID_PICTURE)
		WHERE ID_COMMENT > {int:last_com}
		ORDER BY c.ID_COMMENT ASC
		LIMIT {int:limit}",
		array(
			'last_com' => (int) $last_com,
			'limit' => 1000,
		),__FILE__,__LINE__);
	while ($row = $amFunc['db_fetch_assoc']($request))
	{
		if (isOverLoaded())
			break;

		// Add it (approved is set to 1 temporarily)
		$amFunc['db_insert'](
			'{db_prefix}aeva_comments',
			array('id_comment', 'id_member', 'id_album', 'id_media', 'message', 'posted_on', 'approved'),
			array($row['id_comment'], $row['id_member'], $row['id_cat'], $row['id_pic'], $row['comment'], $row['date'], 1),
			__FILE__,__LINE__);

		aeva_updateSettings('sgp_converted_coms', $amSettings['sgp_converted_coms'] + 1);
	}
	$amFunc['db_free_result']($request);

	// How much are we done?
	$context['current_percentage'] = empty($amSettings['sgp_total_coms']) ? 100 : round((100 / $amSettings['sgp_total_coms']) * $amSettings['sgp_converted_coms'], 2);
	$context['overall_percentage'] += empty($amSettings['sgp_total_coms']) ? $context['steps'][$context['current_step']][2] : round(($context['steps'][$context['current_step']][2] / $amSettings['sgp_total_coms']) * $amSettings['sgp_converted_coms'], 2);

	if ($amSettings['sgp_converted_coms'] < $amSettings['sgp_total_coms'])
	{
		$context['is_halted'] = true;
		haltConversion($converter_url . '?step='.$context['current_step']);
	}
}

// Convert reports
function ConvertReports()
{
	global $amFunc, $context, $converter_url, $amSettings;

	$context['sub_template'] = 'mgc_convert_reports';
	$context['is_halted'] = false;

	// Load the reports
	$request = convert_query('
		SELECT r.ID AS id, r.ID_PICTURE AS id_pic, r.date, r.ID_MEMBER AS id_mem, r.comment, p.title
		FROM {db_prefix}gallery_report AS r
			INNER JOIN {db_prefix}gallery_pic AS p ON (p.ID_PICTURE = r.ID_PICTURE)
		ORDER BY ID ASC
		LIMIT {int:start}, {int:limit}',
		array(
			'start' => $_REQUEST['start'],
			'limit' => 1000,
		),__FILE__,__LINE__);
	while ($row = $amFunc['db_fetch_assoc']($request))
	{
		if (isOverLoaded())
			break;
		$amFunc['db_insert'](
			'{db_prefix}aeva_variables',
			array('type','val1','val2','val3', 'val4', 'val5'),
			array('item_report', $row['id'], $row['date'], $row['comment'], $row['id_pic'], $row['title'])
			,__FILE__,__LINE__);
		aeva_updateSettings('sgp_converted_reports', $amSettings['sgp_converted_reports'] + 1);
	}
	$amFunc['db_free_result']($request);

	// How much are we done?
	$context['current_percentage'] = $amSettings['sgp_total_reports'] > 0 ? round((100 / $amSettings['sgp_total_reports']) * $amSettings['sgp_converted_reports'], 2) : 100;
	$context['overall_percentage'] += $amSettings['sgp_total_reports'] > 0 ? round(($context['steps'][$context['current_step']][2] / $amSettings['sgp_total_reports']) * $amSettings['sgp_converted_reports'], 2) : $context['steps'][$context['current_step']][2];

	if ($amSettings['sgp_converted_reports'] < $amSettings['sgp_total_reports'])
	{
		$context['is_halted'] = true;
		haltConversion($converter_url.'?step='.$context['current_step'].';start='.$amSettings['sgp_converted_reports']);
	}
}

// Recount totals
function Recount()
{
	global $amFunc, $context, $sourcedir;

	require_once($sourcedir . '/Aeva-Admin2.php');
	aeva_admin_maintenance_recount();

	$context['sub_template'] = 'mgc_recount';
	$context['overall_percentage'] += $context['steps'][$context['current_step']][2];
}

function DeleteTempSettings($settings)
{
	foreach ($settings as $setting)
		convert_query('
			DELETE FROM {db_prefix}aeva_settings
			WHERE name = {string:name}', array('name' => $setting),__FILE__,__LINE__);
}

// We are done! :D
function Finish()
{
	global $context;

	// Shh! No one has to know...
	convert_query('
		INSERT INTO {db_prefix}aeva_log_ratings (id_media, id_member, rating)
		SELECT ID_PICTURE, ID_MEMBER, value FROM {db_prefix}gallery_rating', array(),__FILE__,__LINE__);
	convert_query('
		UPDATE {db_prefix}aeva_log_ratings SET time = UNIX_TIMESTAMP()', array(),__FILE__,__LINE__);

	DeleteTempSettings(array(
		'sgp_total_items', 'sgp_total_cats', 'sgp_total_coms', 'sgp_total_reports', 'sgp_last_gen',
		'sgp_converted_items', 'sgp_converted_cats', 'sgp_converted_reports', 'sgp_converted_coms'));

	$context['sub_template'] = 'mgc_finish';
}


// The templates
// These are the ones which output stuff.

function isOverLoaded()
{
	global $context, $time_start;
	$load_time = round(array_sum(explode(' ', microtime())) - array_sum(explode(' ', $time_start)), 3);

	if ($load_time >= $context['max_exec'])
		return true;
	return false;
}
function haltConversion($url)
{
	global $context;
	$context['html_headers'] = '
		<meta http-equiv="refresh" content="' . $context['wait_time'] . '; url=' . $url . '" />';
	obExit();
}
function template_mg_converter_above()
{
	global $settings, $scripturl, $txt, $context;

	header('Content-Type: text/html;');

	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"', !empty($txt['lang_rtl']) ? ' dir="rtl"' : '', '>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
		<title>Aeva Media gallery converter</title>', $context['html_headers'], '
		<link rel="stylesheet" type="text/css" href="', $settings['default_theme_url'] , '/style.css" />
		<style type="text/css">
			div#header
			{
				background-image: url(Themes/default/images/catbg.jpg);
				background-repeat: repeat-x;
				background-color: #88A6C0;
				padding: 22px 4% 12px 4%;
				color: white;
				font-family: Georgia, serif;
				font-size: xx-large;
				border-bottom: 1px solid black;
				height: 40px;
			}
			.stepdone
			{
				color: darkgreen;
				font-size: xx-small;
			}
			.stepcurrent
			{
				color: darkblue;
				font-size: xx-small;
				font-weight: bold;
			}
			.stepwaiting
			{
				color: black;
				font-size: xx-small;
			}
			.smalltext
			{
				font-size: x-small;
				font-family: verdana, sans-serif;
			}
			.mgc_error
			{
				font-size: large;
				text-align: center;
				font-weight: bold;
				color: red;
				padding: 6px;
			}
			.footer
			{
				text-align: center;
				font-size: x-small;
			}
			.loadtime
			{
				text-align: center;
				font-size: x-small;
			}
		</style>
	</head>
	<body>
		<div id="header">
			<div title="Moogle Express!">Aeva Media gallery converter</div>
		</div>
		<div id="content">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" style="padding-top: 1ex;">
				<tr>
					<td width="200" valign="top" style="padding-right: 10px;">
						<table border="0" cellpadding="8" cellspacing="0" class="tborder" width="200">
							<tr>
								<td class="titlebg">Steps</td>
							</tr>
							<tr>
								<td class="windowbg2">';

	foreach ($context['steps'] as $s)
		echo '<span class="',$s['is_current'] ? 'stepcurrent' : ($s['is_done'] ? 'stepdone' : 'stepwaiting'),'">',$s[0],'</span><br />';

	echo '
								</td>
							</tr>
							<tr>
								<td class="titlebg">Progress</td>
							</tr>
							<tr>
								<td class="windowbg2">
									<div class="smalltext" style="text-align: center; padding: 3px 3px 6px 3px;">Overall progress:</div>
									<div style="font-size: 8pt; height: 12pt; border: 1px solid black; background-color: white; position: relative;">
										<div id="overall_text" style="padding-top: 1pt; width: 100%; z-index: 2; color: black; position: absolute; text-align: center; font-weight: bold;">', $context['overall_percentage'], '%</div>
										<div id="overall_progress" style="width: ', $context['overall_percentage'], '%; height: 12pt; z-index: 1; background-color: yellow;">&nbsp;</div>
									</div>';

	if (!empty($context['current_percentage']))
		echo '
										<div class="smalltext" style="text-align: center; padding: 3px 3px 6px 3px;">Current step progress:</div>
										<div style="font-size: 8pt; height: 12pt; border: 1px solid black; background-color: white; position: relative;">
											<div id="overall_text" style="padding-top: 1pt; width: 100%; z-index: 2; color: black; position: absolute; text-align: center; font-weight: bold;">', $context['current_percentage'], '%</div>
											<div id="overall_progress" style="width: ', $context['current_percentage'], '%; height: 12pt; z-index: 1;  background-color: #EEBAF4;">&nbsp;</div>
										</div>';

	// Get the total time executed
	$total_executed = time() - $context['mgc_start'];
	$mins = (int) ($total_executed / 60);
	$seconds = $total_executed - $mins * 60;

	echo '
										<div class="smalltext" style="padding: 5px; text-align: center;">Total time elapsed:</div>
										<div class="smalltext" style="color: blue; text-align: center;"><span id="mins_elapsed">', $mins, '</span> minutes, <span id="secs_elapsed">', $seconds, '</span> seconds.</div>';
	echo '
								</td>
							</tr>
						</table>
					</td>
					<td width="100%" valign="top">';
}

// Template of welcome page
function template_mgc_welcome()
{
	global $context, $converter_url;
	// Let's show them the welcome page
	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Welcome</td>
			</tr>
			<tr class="windowbg2">
				<td>
					Welcome to the SMF Gallery Pro converter for Aeva Media, and thank you for trying out Aeva Media.<br /><br />This converter in simple steps will convert your SMF Gallery Pro database items to Aeva Media. Time taken will depend on the size of your database.<br /><br />
					Total items: ', $context['mgc_num_items'],'<br />
					Total categories: ',$context['mgc_num_cats'],'<br />
					Total comments: ',$context['mgc_num_coms'],'<br />
					Total reports: ',$context['mgc_num_reports'],'<br /><br />
					<div style="font-weight: bold; font-size: 13px;">Please Note: Your Aeva Media installation will be cleaned, meaning all categories, items, comments etc will be deleted, before converting. However, Your SMF Gallery\'s installation will remain unchanged</div><br />
					<div style="text-align: right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</a></div>
				</td>
			</tr>
		</table>';
}

// Template of load conversion
function template_mgc_loadconversion()
{
	global $context, $coversion_url;
	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Loading conversion</td>
			</tr>
			<tr class="windowbg2">
				<td>The converter is ready to process.
				<div style="text-align:right"><a href="', $converter_url, '?step=', $context['current_step'] + 1, '">Next</div>
				</td>
			</tr>
		</table>';
}
// Template of conversion of albums
function template_mgc_convert_cats()
{
	global $converter_url, $context;

	// Start the output
	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert categories</td>
			</tr>
			<tr class="windowbg2">
				<td>';
			foreach ($context['converted_cats'] as $cat)
				echo '
					<div>
						Converted ',$cat,'
					</div>';
		if ($context['is_halted'])
			echo '
					The conversion has been halted to avoid overloading your server. It will automatically resume in ',$context['wait_time'],' second(s).';
		else
			echo '
				<div>Conversion of categories has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}
// Template of conversion of items
function template_mgc_convert_items()
{
	global $converter_url, $context, $amSettings;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert items</td>
			</tr>
			<tr class="windowbg2">
				<td>';
		if ($context['is_halted'])
			echo '
					The conversion has been halted to avoid overloading your server. So far, ', $amSettings['sgp_converted_items'], ' items out of ', $amSettings['sgp_total_items'],' have been converted. The script will automatically resume in ',$context['wait_time'],' second(s).';
		else
			echo '
				<div>Conversion of items has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}

// Template for comment converter
function template_mgc_convert_coms()
{
	global $converter_url, $context, $amSettings;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert comments</td>
			</tr>
			<tr class="windowbg2">
				<td>';
	if ($context['is_halted'])
		echo 'The conversion has been halted to avoid overloading your server. So far, ', $amSettings['sgp_converted_coms'], ' comments out of ', $amSettings['sgp_total_coms'],' have been converted. The script will automatically resume in ',$context['wait_time'],' second(s).';
	else
		echo '
				<div>Conversion of comments has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}

// Convert reports
function template_mgc_convert_reports()
{
	global $converter_url, $context, $amSettings;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Convert reports</td>
			</tr>
			<tr class="windowbg2">
				<td>';
	if ($context['is_halted'])
		echo '
				The conversion has been halted to avoid overloading your server. So far, ', $amSettings['sgp_converted_reports'], ' reports out of ', $amSettings['sgp_total_reports'],' have been converted. The script will automatically resume in ',$context['wait_time'],' second(s).';
	else
		echo '
				<div>Conversion of reports has been completed</div>
				<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>';
	echo '
				</td>
			</tr>
		</table>';
}

// Recount totals
function template_mgc_recount()
{
	global $converter_url, $context;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Recount statistics</td>
			</tr>
			<tr class="windowbg2">
				<td>
					<div>The Recount maintenance task has been successfully executed.</div>
					<div style="text-align:right;"><a href="',$converter_url,'?step=',$context['current_step'] + 1,'">Next</div>
				</td>
			</tr>
		</table>';
}

// Finish
function template_mgc_finish()
{
	global $context, $galurl, $galurl2, $scripturl;

	echo '
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
			<tr class="titlebg">
				<td align="center">Finished</td>
			</tr>
			<tr class="windowbg2">
				<td>
					The converter has finished converting SMF Gallery Pro to Aeva Media<br /><br />
					<a href="'.$scripturl.'">Go to your forum</a><br />
					<a href="'.$galurl2.'">Go to your newly converted gallery</a><br /><br />
					<b>It is recommended to remove this converter</b>
				</td>
			</tr>
			<tr>
				<td>';

	if (is_writable(dirname(__FILE__)) || is_writable(__FILE__))
		echo '
					<label for="delete_self"><input type="checkbox" id="delete_self" onclick="doTheDelete(this);" /> Delete this file.</label> <i>(doesn\'t work on all servers.)</i>
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						function doTheDelete(theCheck)
						{
							var theImage = document.getElementById ? document.getElementById("delete_upgrader") : document.all.delete_upgrader;

							theImage.src = "', $_SERVER['PHP_SELF'], '?delete=1&ts_" + (new Date().getTime());
							theCheck.disabled = true;
						}
					// ]]></script>
					<img src="', $boardurl, '/Themes/default/images/blank.gif" alt="" id="delete_upgrader" />';

	echo '
				</td>
			</tr>
		</table>';
}

// The below template of converter
function template_mg_converter_below()
{
	global $time_start, $context, $db_count, $amSettings;
	echo '
					</td>
				</tr>
			</table>
			<div class="footer">
				Aeva Media '.$amSettings['version'].' &copy; <a href="http://noisen.com/">noisen</a> / <a href="http://smf-media.com">smf-media</a>
			</div>
			<div class="loadtime">
				Page loaded in ',round(array_sum(explode(' ', microtime())) - array_sum(explode(' ', $time_start)), 3),' seconds with '.$db_count.' queries
			</div>
		</div>
	</body>
</html>';
}

function convert_query($query, $values, $file, $line)
{
	global $context, $amFunc;
	if ($context['is_gallery2'])
		return $amFunc['db_query'](filter_columns($query), $values, $file, $line);
	else
		return $amFunc['db_query']($query, $values, $file, $line);
}

function filter_columns($str)
{
	$columns = array(
		'ID_PICTURE' => 'id_picture',
		'ID_CAT' => 'id_cat',
		'ID_MEMBER' => 'id_member',
		'ID' => 'id',
		'ID_COMMENT' => 'id_comment',
		'ID_PARENT' => 'id_parent'
	);
	return str_replace(array_keys($columns), array_values($columns), $str);
}

// Shows an error
function converterError($msg)
{
	global $context;
	$context['sub_template'] = 'mgc_error';
	$context['converter_msg'] = $msg;
	// Exit to prevent further execution
	obExit();
}

function template_mgc_error()
{
	global $context;
	echo '
		<div class="titlebg mgc_error">Error</div>
		<div class="windowbg2">
			',$context['converter_msg'],'
		</div>';
}

?>